<?php

$includecbs=array("repos", "triv", "trav", "maybei", "arc", "asidei", "clut", "junk", "gone");

$onlycbs = array("fv", "imp", "frq", "aor", "aes", "util", "edu", "fun4", "hum", "nws", "cur", "reposo", "site4", "cluto", "trivo", "travo", "savo", "maybeo", "arco", "asideo", "junko");

$ordercbs = array("reador", "dateor", "freqor", "necor", "likeor", "intror", "qualor", "aesor", "utilor", "eduvalor", "funor", "humorder", "modor", "addor", "typeor", "titleor");


$hostnamecommands = array ("h", "ho", "hn", "host", "hosts", "hostname");
$hostnameorcommands = array ("hoo", "hor", "hno", "hnor", "hosto", "hostor", "hostsor", "hostnameor");
$hostnamexcommands = array("hx", "hox", "hnx", "xh", "xhn", "xhost", "xhosts", "hostx", "hostnamex", "exacthost");

$suffixcommands=array("su", "suf", "tld", "suffix");

$pathcommands = array("pa", "pat", "path");
$pathorcommands = array("po", "pao", "patho", "pathor");
$pathxcommands = array("px", "xp", "pax", "xpa", "pathx", "xpath", "exactpath");

$filenamecommands = array ("f", "fn", "fnl", "file", "filename");
$filenameorcommands = array ("fo", "fno", "for", "fnor", "fileor");
$filenamexcommands = array ("fx", "fnx", "filex", "filenamex", "exactfile", "exactfilename");


$titlecommands = array ("ti", "title");
$titleorcommands = array ("to", "tor", "titleor");
$titlexcommands = array ("tx", "titlex", "exactitle");

$pagetypecommands = array("ty", "typ", "type", "pagetype");
$pagetypeorcommands = array("tyo", "typo", "typor", "typeor", "pagetypeor");
$pagetypexcommands = array("tyx", "typx", "typex", "pagetypex", "exactype", "exactpagetype");


$usesymbolscommands = array("sy", "sym", "symb", "symbols");
$nosymbolscommands = array("nsy", "nosym", "nosymb", "nosymbols");

$pagenumcommands = array ("p", "page");
$linknumcommands = array ("#", "n", "ln", "links", "linknum", "linksnum");

$ignorecbcommands = array ("ic", "cb", "ccb", "igc", "igcb", "ignorecb", "ignorecheckboxes", "clearcb", "clearcheckboxes");
$ignoreincludecbcommands = array("igi", "iginc", "ignoreinc", "ignoreincs");
$ignoreonlycbcommands = array("igo", "igonly", "ignoreonly", "ignoreonlys");
$ignoreordercbcommands = array("io", "ior", "igor", "igorders", "ignoreorder", "ignoreorders");

$ascs=array("a", "as", "asc");
$descs=array("d", "de", "des", "desc");
$lastreadcommands = array("lr", "read", "lastread");


$ordercommands = array("o", "or", "ord", "order");

$listoforders=array("lastread", "date", "updatefrequency", "necessity", "liking", "interest", "quality", "beauty", "usefulness", "eduval", "fun", "humorousness", "pagetype", "title", "whenmodified", "whenadded");

$read_abrev=array("read", "whenread");
$date_abrev=array("da", "dat");
$freq_abrev=array("up", "upd", "frq", "freq", "update");
$nec_abrev=array("ne", "nec");
$lik_abrev=array("li", "lik", "like");
$int_abrev=array("in", "int", "intr");
$qual_abrev=array("qu", "qua", "qual");
$beau_abrev=array("ae", "aes", "bea", "beau");
$use_abrev=array("us", "ut", "use", "uti", "util");
$eduv_abrev=array("ed", "edu", "educ", "eduv");
$funv_abrev=array("fu");
$humv_abrev=array("hu", "hum", "humor");
$type_abrev=array("ty", "typ", "type");
$title_abrev=array("ti", "titl");
$mod_abrev=array("mo", "mod", "lm");
$add_abrev=array("ad", "add", "added");


$order_abrev_arrs=array("read_abrev" => "lastread", "date_abrev" => "date", "freq_abrev" =>"updatefrequency", "nec_abrev" => "necessity", "lik_abrev" => "liking", "int_abrev" => "interest", "qual_abrev" => "quality", "beau_abrev" => "beauty", "use_abrev" => "usefulness", "eduv_abrev" => "eduval", "eduv_abrev" => "eduval", "funv_abrev" => "fun", "humv_abrev" => "humorousness", "type_abrev" => "pagetype", "title_abrev" => "title", "mod_abrev" => "whenmodified", "add_abrev" => "whenadded");

function ExpandOrderAbbrev(&$inp)
{	global $order_abrev_arrs;

	foreach ($order_abrev_arrs as $arr => $key)
	{	global ${$arr};
		if (in_array ($inp, ${$arr} ) )
		{	$inp = $key; return;
		}
	}
}

$onlycommands = array ("only", "y", "is", "has", "yes", "in", "of", "ol", "onl", "on");

$attributes = array ("repository", "trivial", "savedfile", "dead", "fav", "maybe", "archive", "aside", "clutterpile", "junkpile", "important", "aesthetic", "utilit", "forfun", "educational", "humorous", "news", "frequent", "travelog", "notinarchiveorg", "aodeny", "curio", "forsite", "usedonsite", "gone");

$rep_abrev=array("re", "rep", "repo", "repos");
$triv_abrev=array("tri", "triv");
$sav_abrev=array("sf", "sav", "saved", "savedfile");
$gone_abrev=array("go", "gn", "gon");
$fav_abrev=array("fv", "fa", "favo", "favor", "favorite");
$maybe_abrev=array("mb", "ma", "may", "mayb");
$clut_abrev=array("clu", "clu", "clut", "clutr");
$junk_abrev=array("jn", "jk", "jun", "jnk", "junk");
$imp_abrev=array("im", "imp", "impo", "import");
$aes_abrev=array("ae", "aes", "aesth");
$util_abrev=array("ut", "uti", "util", "utilitarian");
$fun_abrev=array("fu", "fun");
$hum_abrev=array("hu", "hum", "humor");
$news_abrev=array("ne", "nw", "nws");
$cur_abrev=array("cu", "cur", "curi");
$asi_abrev=array("as", "asi", "asid");
$trav_abrev=array("tra", "trav");
$edu_abrev=array("edu", "educ");
$arc_abrev=array("ar", "arc", "arch", "archi", "archiv");

$site4_abrev=array("si", "4s", "4site", "site");
$usedsite4_abrev=array("ud", "usd", "used");

$abrev_arrs=array("rep_abrev" => "repository", "triv_abrev" => "trivial", "trav_abrev" =>"travelog", "maybe_abrev" => "maybe",  "arc_abrev" => "archive", "clut_abrev" => "clutterpile", "junk_abrev" => "junkpile", "site4_abrev" => "forsite", "sav_abrev" => "savedfile", "usedsite4_abrev" => "usedonsite", "gone_abrev" => "gone", "fav_abrev" => "fav", "imp_abrev" => "important", "aes_abrev" => "aesthetic", "util_abrev" => "utilit", "edu_abrev" => "educational", "fun_abrev" => "forfun", "hum_abrev" => "humorous", "news_abrev" => "news", "cur_abrev" => "curio", "asi_abrev" => "aside");

function ExpandAbbrev(&$inp)
{	global $abrev_arrs;

	foreach ($abrev_arrs as $arr => $key)
	{	global ${$arr};
		if (in_array ($inp, ${$arr} ) )
		{	$inp = $key; return;
		}
	}
}

$includecommands = array ("i", "inc", "incl", "inclu", "include");
$includeattributes = array("repository", "trivial", "clutterpile", "travelog", "maybe", "archive", "aside", "junkpile", "gone");

$includeallcommands = array("ia", "inca", "incall", "includeall");
$includeintcommands = array("ii", "inci", "incint");
$includequestioncommands = array("iq", "incq", "?", "??", "???");

$excludecommands = array ("x",  "exclude", "xc", "xcl", "xclude", "n", "no", "not", "isnt", "hasnt", "notin", "notof");

$cats=array("aesthetic", "utilit", "educational", "forfun", "humorous", "news", "curio");

$excludeallmaincats = array("xa", "xac", "xamc", "excludeallmaincats");
$excludeothermaincats = array("xc", "xoc", "excludeothercats");

$excludeboringcommands = array("xb", "exb", "excludeboring");
$excludesubtagcommands = array("ns", "nsb", "nst", "nosub", "nosubtag");


$anytagcommands = array("t", "tg", "ta", "tag", "tags", "at", "anyt", "anytag");
$anytagorcommands = array("tao", "tago", "tagso", "tagsor", "tagor", "ato", "ator", "anytagor");

$maintagcommands = array ("mta", "mtag", "mtags", "maintag", "maintags");
$maintagorcommands = array("mtao", "mtago", "mtagso", "maintagor", "maintagsor");

$othertagcommands = array ("ot", "oth", "otht", "othert", "othertag", "othertags");
$othertagorcommands = array ("oto", "otor", "othertagor", "othertagsor");

$projectagcommands = array ("pj", "pt", "prj", "pjt", "projt", "projectag", "project");
$projectagorcommands = array("pjo", "pjor", "ptor", "pjtor", "projtor", "projectagor", "projector");

$bundletagcommands = array("bu", "bt", "bun", "but", "bundt", "bund", "bundle", "bundletag");
$bundletagorcommands = array("bto", "buto", "butor", "bundtor", "bundor", "bundleor", "bundletagor");

$authortagcommands = array("au", "aut", "auth", "autag", "author", "authortag");
$authortagorcommands = array("auo", "auor", "autor", "autagor", "authoror", "authortagor");

$languagetagcommands = array ("la", "lan", "lang", "langs", "language", "languages");
$languagetagorcommands = array("lano", "lanor", "langor", "languageor", "languagesor");


$allanytagcommands = array_merge($anytagcommands, $anytagorcommands);
$allmaintagcommands = array_merge($maintagcommands, $maintagorcommands);
$allothertagcommands = array_merge($othertagcommands, $othertagorcommands);
$allprojectagcommands = array_merge($projectagcommands, $projectagorcommands);
$allbundletagcommands = array_merge($bundletagcommands, $bundletagorcommands);
$allauthortagcommands = array_merge($authortagcommands, $authortagorcommands);
$alllanguagetagcommands = array_merge($languagetagcommands, $languagetagorcommands);

$alltagorcommands = array_merge($anytagorcommands, $maintagorcommands, $othertagorcommands, $projectagorcommands, $bundletagorcommands, $authortagorcommands, $languagetagorcommands);

$tagtablecommands = array();
$tagtablecommands = array_merge($anytagcommands, $anytagorcommands, $maintagcommands, $maintagorcommands, $othertagcommands, $othertagorcommands, $projectagcommands, $projectagorcommands, $bundletagcommands, $bundletagorcommands, $authortagcommands, $authortagorcommands, $languagetagcommands, $languagetagorcommands);

$list_allcommandarrays=array("titlecommands", "titleorcommands", "titlexcommands", "pathcommands","pathorcommands", "pathxcommands", "pagetypecommands", "pagetypeorcommands", "pagetypexcommands", "filenamecommands", "filenameorcommands", "filenamexcommands", "anytagcommands", "anytagorcommands", "maintagcommands", "maintagorcommands", "othertagcommands", "othertagorcommands", "projectagcommands", "projectagorcommands", "bundletagcommands", "bundletagorcommands", "authortagcommands", "authortagorcommands", "languagetagcommands", "languagetagorcommands", "onlycommands", "excludecommands", "includecommands", "ordercommands", "includeintcommands", "includeallcommands", "ignoreincludecbcommands", "ignoreonlycbcommands", "ignorecbcommands", "ignoreordercbcommands", "pagenumcommands", "linknumcommands", "excludeboringcommands", "hostnamecommands", "hostnamexcommands", "suffixcommands", "excludesubtagcommands", "excludeallmaincats", "excludeothermaincats", "ascs", "descs", "lastreadcommands", "includequestioncommands", "hostnameorcommands", "usesymbolscommands", "nosymbolscommands");

$allcommands = array();

foreach ($list_allcommandarrays as $arr)
{
	$allcommands = array_merge( $allcommands, ${$arr} );
}

function TagSubquery ($inornot, $likeorin, $tagidnums, $tagtypestuff)
{
	$res="\nAND urlinfo.url_id $inornot
(
		SELECT urlinfo.url_id 
		FROM urlinfo, tags, urltagmap 
		WHERE urlinfo.dead ='n' 
	
		AND urlinfo.url_id = urltagmap.url_id 
		AND Tags.tag_id = urltagmap.tag_id
		AND
		( 
			(	Tags.tag_name $likeorin ($tagidnums)  $tagtypestuff
			)
		)
)";
	return $res;
}


function GetTagidStringFromTagArr($arr)
{	global $array_existingtagsandids;

	$numoftags=count($arr);
	$x=0;
	while ($x<$numoftags)
	{	$tagname=$arr[$x];
		$thistagid[$x]=$array_existingtagsandids[$tagname];
		$tagids .= "$thistagid[$x], ";
		$x++;
	}
	$tagids=substr($tagids, 0, -2);
	return $tagids;
}


function ParseSearchQuery($searchquery, $dontsavexq=false)
{	global $list_allcommandarrays;

	foreach ($list_allcommandarrays as $arr)
	{	global ${$arr};
	}
	
    global $tagtablecommands, $allcommands, $alllikecommands, $alllabelcommands,     
  $lengthcomparecommands,  $num_of_args, $indiv_args, $outlist, $inlist, $roletablequery, $displaylinks, $displayeditlinks, $outputeditfile, $outputsearch, $outputplaylist, $getsongidornot, $allanytagcommands, $tagtablequery, $alladjectivecommands, $allgenrecommands, $allanyinstrumentcommands, $allleadinstrumentcommands, $allotherinstrumentcommands, $allanyinstrumentcommands, $alltagorcommands, $prevtagcommandissued, $allmaintagcommands, $allothertagcommands, $allprojectagcommands, $allbundletagcommands, $allauthortagcommands, $alllanguagetagcommands, $attributes, $listoforders, $asc, $ascs, $descs, $executequery, $thisearchquery, $cats;

	$searchquery=ereg_replace("\n", ";\n", $searchquery);
  	$thisearchquery=$searchquery;

	$indiv_commands=explode(";", $searchquery);

	array_walk($indiv_commands,trim_value);

	$num_of_commands=count($indiv_commands);


	$x=0;
	while ($x<$num_of_commands)
	{
		$splitcommand=explode(" ", $indiv_commands[$x]);
		$thiscommand=array_shift($splitcommand);
		$thiscommand=strtolower($thiscommand);
		$len=strlen($thiscommand);

		$args=substr($indiv_commands[$x],$len);
		
		$indiv_args=explode(",", $args);

		array_walk($indiv_args,trim_value);

		$num_of_args=count($indiv_args);

		$test=substr($thiscommand, 0, 1);
		if ($test=="!")
		{	$negcommand=substr($thiscommand,1);
		}

	if ( in_array($thiscommand, $allcommands) )
	{
		if ( in_array($thiscommand, $excludeothermaincats) )
		{	
			global $aes, $util, $edu, $fun4, $hum, $nws, $cur;

			$catshash=array("aes" => "aesthetic", "util" => "utilit", "edu" => "educational", "fun4" => "forfun", "hum" => "humorous", "nws" => "news", "cur" => "curio");
			foreach ($catshash as $catvar => $catname)
			{	if (${$catvar}!="y")
				{
					$query_part2 .= "\nAND urlinfo.$catname = 'n' ";
				}
			 }
		}
		else if ( in_array($thiscommand, $excludeallmaincats) )
		{
			foreach ($cats as $cat)
			{
				$query_part2 .= "\nAND urlinfo.$cat = 'n' ";
			}
		}
		else if ( in_array($thiscommand, $ascs) )
		{	global $asc;
			$asc="asc";
		}
		else if ( in_array($thiscommand, $descs) )
		{	global $asc;
			$asc="desc";
		}
		else if ( in_array($thiscommand, $excludesubtagcommands) )
		{	
			global $excludesubtags;
			$excludesubtags=true;
		}
		else if ( in_array($thiscommand, $lastreadcommands) )
		{	global $asc, $reador;
			$asc="asc";
			$reador="y";
		}
		else if ( in_array($thiscommand, $usesymbolscommands) )
		{	global $usesymbols;
			$usesymbols="y";
		}
		else if ( in_array($thiscommand, $nosymbolscommands) )
		{	global $usesymbols;
			$usesymbols="n";
		}
		else if ( in_array($thiscommand, $tagtablecommands) )
		{
			$tagtablequery="true";
			if (!$dontsavexq)
			{
				$executequery=$thisearchquery;
			}
			global $array_existingtagsandids;
			$tagtablequery=true;

			$outlist = array();
			$inlist = array();

			$likeorin="IN";
			$enclosure="\"";

			array_walk($indiv_args, ArrayWalkInOrNot);
			$tagtypestuff = " AND urltagmap.tagtypenum IN ";

			if ( in_array($thiscommand,$allanytagcommands ) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(1, 3, 5, 7, 9, 11)";
				}
				else
				{	$tagtypestuff = "";
				}
			}

			else if ( in_array($thiscommand,$allmaintagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(1)";
				}
				else
				{
					$tagtypestuff .= "(1, 2)";
				}
			}
			else if ( in_array($thiscommand,$allothertagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(3)";
				}
				else
				{
					$tagtypestuff .= "(3, 4)";
				}
			}
			else if ( in_array($thiscommand,$allprojectagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(5)";
				}
				else
				{
					$tagtypestuff .= "(5, 6)";
				}
			}
			else if ( in_array($thiscommand,$allbundletagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(7, 13)";
				}
				else
				{
					$tagtypestuff .= "(7, 8, 13, 14)";
				}
			}
			else if ( in_array($thiscommand,$allauthortagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(9)";
				}
				else
				{	$tagtypestuff .= "(9, 10)";
				}
			}
			else if ( in_array($thiscommand,$alllanguagetagcommands) )
			{	if ($excludesubtags)
				{	$tagtypestuff .= "(11)";
				}
				else
				{	$tagtypestuff .= "(11, 12)";
				}
			}

			if (!empty ($inlist) )
			{			
				array_walk($inlist,EncloseInSomething, $enclosure);
				$num_of_in=count($inlist);
				$regluedin=implode(", ", $inlist);
			}
			if (!empty ($outlist) )
			{
				array_walk($outlist,EncloseInSomething, $enclosure);
				$num_of_out=count($outlist);
				$regluedout=implode(", ", $outlist);
			}

			if ( in_array($thiscommand, $alltagorcommands) )
			{
				if (!$prevtagcommandissued)
				{
					if ( isset($regluedin) )
					{	if ($likeorin=="IN")
						{
							$query_part2 .= "\nAND ( (Tags.tag_name $likeorin ($regluedin) ) $tagtypestuff )";
						}
						else
						{	$y=0;
							$query_part2 .= "\nAND ( (";
							while ($y<$num_of_in)
							{	$thisarg=$inlist[$y];
								if ($y>0)
								{	$query_part2 .= "OR";
								}
								$query_part2 .=  " ( Tags.tag_name $likeorin ($thisarg) ) ";
								$y++;
							}
							$query_part2 .= ") $tagtypestuff )";
						}
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);
					}
				}
				else if ($prevtagcommandissued)
				{	if ( isset($regluedin) )
					{
						$query_part2 .= TagSubquery("IN", $likeorin, $regluedin, $tagtypestuff);
					}
					if ( isset($regluedout) )
					{
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $regluedout, $tagtypestuff);	
					}
				}
			}
			else //if (! in_array($thiscommand, $alltagorcommands) ) //If it's not an "or" command...
			{	if ($likeorin=="IN")
				{	$likeorin="=";
				}
				$z=0;
				if ( !empty ($inlist) )
				{	if (!$prevtagcommandissued)
					{	$thisarg=$inlist[0];
						$query_part2 .= "\nAND ( (Tags.tag_name $likeorin $thisarg ) $tagtypestuff )";
						$z=1;
					}
					while ($z<$num_of_in)
					{
						$thisarg=$inlist[$z];
						$query_part2 .= TagSubquery("IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
					$z=0;
				}
				if ( !empty ($outlist) )
				{
					while ($z<$num_of_out)
					{
						$thisarg=$outlist[$z];
						$query_part2 .= TagSubquery("NOT IN", $likeorin, $thisarg, $tagtypestuff);
						$z++;
					}
				}
			}
			unset($regluedin);
			unset($regluedout);

			$prevtagcommandissued="true";
		}
		else
		if ( in_array($thiscommand,$linknumcommands) )
		{	$thislinknum=$indiv_args[0];
			if (is_numeric($thislinknum) )
			{	global $displaythismany;
				$displaythismany=$thislinknum;
			}
		}
		else if ( in_array($thiscommand,$pagenumcommands) )
		{	$thispagenum=$indiv_args[0];
			if (is_numeric($thispagenum) )
			{	global $page;
				$page=$thispagenum;
			}
		}
		else if ( in_array($thiscommand,$titlecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$titleorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("title", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $titlexcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("title", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$hostnamecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("hostname", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$hostnameorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("hostname", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $hostnamexcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("hostname", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $suffixcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("suffix", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$pathcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("path", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$pathorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("path", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $pathxcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("path", "=", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$pagetypecommands) )
		{	$query_part2 .= ConstructTextSearchQuery("pagetype", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$pagetypeorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("pagetype", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand, $pagetypexcommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("pagetype", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$filenamecommands) )
		{
			$query_part2 .= ConstructTextSearchQuery("fullfilename", "LIKE", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$filenameorcommands) )
		{	$query_part2 .= ConstructTextSearchQuery("fullfilename", "LIKE", "SingleQuoted", true);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$filenamexcommands)  )
		{
			$query_part2 .= ConstructTextSearchQuery("fullfilename", "=", "SingleQuoted", false);
			$executequery=$thisearchquery;
		}
		else if ( in_array($thiscommand,$excludeboringcommands ) )
		{	global $clut, $junk, $gone;
			$clut=""; $junk=""; $gone="";
		}
		else if ( in_array($thiscommand,$includequestioncommands) )
		{	global $repos, $triv, $trav;
			$repos="y"; $triv="y"; 	$trav="y";
		}
		else if ( in_array($thiscommand,$includeintcommands ) )
		{
			global $maybei, $arc, $asidei;
			$asidei="y"; $arc="y";
			$maybei="y";
		}
		else if ( in_array($thiscommand,$includeallcommands ) )
		{
			global $repos, $triv, $trav, $maybei, $asidei, $clut, $junk, $gone, $arc;
			$repos="y"; $triv="y"; $clut="y"; $junk="y";
			$trav="y"; $maybei="y"; $gone="y"; $asidei="y"; $arc="y";
		}
		else if ( in_array($thiscommand, $ignorecbcommands ) )
		{	global $onlycbs, $includecbs, $ordercbs;
			$allcbs=array_merge($onlycbs, $includecbs, $ordercbs);

			foreach ($allcbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreordercbcommands ) )
		{	global $ordercbs;
			foreach ($ordercbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreonlycbcommands ) )
		{	global $onlycbs;
			foreach ($onlycbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand, $ignoreincludecbcommands ) )
		{	global $includecbs;
			foreach ($includecbs as $var)
			{	global ${$var};
				${$var}="";
			}
		}
		else if ( in_array($thiscommand,$onlycommands) )
		{	$y=0;
			$executequery=$thisearchquery;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $attributes) )
				{
					ExpandAbbrev($thisarg);
				}
				if (in_array($thisarg, $attributes))
				{
					if ($thisarg!="forsite" && $thisarg!="usedonsite" && $thisarg!="gone" )
					{	$query_part2 .= "\nAND urlinfo.$thisarg = 'y' ";
					}
					else if ($thisarg=="usedonsite")
					{	$query_part2 .= "\nAND forsite = 'used' ";
						$executequery=$thisearchquery;
					}
					else if ($thisarg=="gone")
					{
						$query_part2 .= " AND (UrlInfo.dead ='y' AND ( UrlInfo.notinarchiveorg='y' OR UrlInfo.aodeny='y') AND UrlInfo.archiveorg='n') ";
						global $gone;
						$gone="y";
					}
					switch ($thisarg)
					{	case "repository": global $reposo; $reposo="y"; break;
						case "trivial": global $trivo; $trivo="y"; break;
						case "clutterpile": global $cluto; $cluto="y"; break;
						case "travelog": global $travo; $travo="y"; break;
						case "maybe": global $maybeo; $maybeo="y"; break;
						case "archive": global $arco; $arco="y"; break;
						case "aside": global $asideo; $asideo="y"; break;
						case "forsite": global $site4; $site4="y"; break;
						case "usedonsite": global $site4; $site4=""; break;
						case "savedfile": global $savo; $savo="y"; break;
						case "gone": global $goneo; $goneo="y"; break;
						case "fav": global $fv; $fv="y"; break;
						case "important": global $imp; $imp="y"; break;
						case "frequent": global $frq; $frq="y"; break;
						case "archiveorg": global $aor; $aor="y"; break;
						case "aesthetic": global $aes; $aes="y"; break;
						case "utilit": global $util; $util="y"; break;
						case "educational": global $edu; $edu="y"; break;
						case "forfun": global $fun4; $fun4="y"; break;
						case "humorous": global $hum; $hum="y"; break;
						case "news": global $nws; $nws="y"; break;
						case "curio": global $cur; $cur="y"; break;
						case "junkpile": global $junk; $junk="y"; break;
					}
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand, $includecommands) )
		{
			$y=0;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $includeattributes) )
				{
					ExpandAbbrev($thisarg);
				}
				if (in_array($thisarg, $includeattributes))
				{
					switch ($thisarg)
					{	case "repository": global $repos; $repos="y"; break;
						case "trivial": global $triv; $triv="y"; break;
						case "clutterpile": global $clut; $clut="y"; break;
						case "travelog": global $trav; $trav="y"; break;
						case "maybe": global $maybei; $maybei="y"; break;
						case "archive": global $arc; $arc="y"; break;
						case "aside": global $asidei; $asidei="y"; break;
						case "junkpile": global $junk; $junk="y"; break;
						case "gone": global $gone; $gone="y"; break;
					}
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand,$ordercommands) )
		{	$y=0;
			$executequery=$thisearchquery;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (strpos($thisarg, " ")==true)
				{
					$splitarg=explode(" ", $thisarg);
					$ascordesc=strtolower($splitarg[1]);

					if (in_array($ascordesc, $ascs) )
					{	$ascordesc="asc";
					}
					else
					if (in_array($ascordesc, $descs) )
					{	$ascordesc="desc";
					}
					if (!$ascordesc)
					{
						global $asc;
						$ascordesc=$asc;
					}
					$thisorder=$splitarg[0];
				}
				else
				{	global $asc;
					$ascordesc=$asc;
					$thisorder=$thisarg;
				}
				
				global $order;
				if (!in_array($thisorder, $listoforders) )
				{	
					ExpandOrderAbbrev($thisorder);
				}
				if (in_array($thisorder, $listoforders) )
				{	
					if ($thisorder!="date")
					{	$finalorder="urlinfo.$thisorder $ascordesc";
					}
					else
					{	$finalorder="urlinfo.maindateyear $ascordesc, urlinfo.maindatemonth $ascordesc, urlinfo.maindateday $ascordesc";
					}
					
					if (!$ordercommandissued)
					{	$order = "$finalorder";
						global $ordercbs;
						foreach ($ordercbs as $var)
						{	global ${$var};
							${$var}="";
						}
					}
					else
					{	$order .= ", $finalorder";
					}
				
					$ordercommandissued=true;
				}
				$y++;
			}
		}
		else if ( in_array($thiscommand,$excludecommands) )
		{	$y=0;
			$executequery=$thisearchquery;
			while ($y<$num_of_args)
			{	$thisarg=$indiv_args[$y];
				if (!in_array($thisarg, $attributes) )
				{
					ExpandAbbrev($thisarg);
				}

				if (in_array($thisarg, $attributes))
				{
					switch ($thisarg)
					{	case "repository": global $repos, $reposo; $repos=""; $reposo=""; break;
						case "trivial": global $triv, $trivo; $triv=""; $trivo=""; break;
						case "clutterpile": global $clut, $cluto; $clut=""; $cluto=""; break;
						case "travelog": global $trav, $travo; $trav=""; $travo=""; break;
						case "maybe": global $maybei, $maybeo; $maybei=""; $maybeo=""; break;
						case "arc": global $arc, $arco; $arc=""; $arco=""; break;
						case "aside": global $asidei, $asideo; $asidei=""; $asideo==""; break;
						case "junkpile": global $junk, $junko; $junk=""; $junko=""; break;
						case "gone": global $gone; $gone=""; break;
						case "forsite": $query_part2 .= "\nAND urlinfo.forsite != 'unused' "; break;
						case "usedonsite": $query_part2 .= "\nAND urlinfo.forsite != 'used' "; break;
						case "fav":
						case "important":
						case "frequent":
						case "archiveorg":
						case "aesthetic":
						case "utilit":
						case "educational":
						case "forfun":
						case "humorous":
						case "news":
						case "curio":
						case "savedfile": $query_part2 .= "\nAND urlinfo.$thisarg = 'n' "; break;
					}
				}
				$y++;
			}
		}
	}
	$x++;

	}
	return $query_part2;
}


function ConstructLengthComparisonQuery($field, $comparison)
{	global $indiv_args, $thisearchquery, $executequery;

	$executequery=$thisearchquery;
	$thisarg=$indiv_args[0];
	$quer = "AND vgSongDetails.$field $comparison $thisarg";
	return $quer;
}

function ConstructTextSearchQuery($field, $comparison, $quotesornot, $forceor)
{	global $num_of_args, $indiv_args, $outlist, $inlist;

	$outlist = array();
	$inlist = array();

	array_walk($indiv_args, ArrayWalkInOrNot);

	$num_of_out=count($outlist);
	$num_of_in=count($inlist);

	if ( !empty($inlist) )

	{	$y=0;
		$quer .= " AND (";
		while ($y<$num_of_in)
		{	$thisarg=$inlist[$y];
			if ($comparison=="LIKE")
			{	$thisarg = "%" . $thisarg . "%";
			}
			if ($quotesornot=="SingleQuoted")
			{	$thisarg = "'" . $thisarg . "'";
			}
			else if ($quotesornot=="DoubleQuoted")
			{	$thisarg = "\"" . $thisarg . "\"";
			}
			if ($y>0)
			{	if ($comparison=="LIKE" && $forceor==false)
				{	$quer .= "\nAND";
				}
				else
				{	$quer .= "\nOR";
				}
			}
			$quer .= " urlinfo.$field $comparison $thisarg";
			$y++;
		}
		$quer .= ")";
	}

	if ( !empty($outlist) )
	{	$y=0;
		$quer .= " AND (";

		while ($y<$num_of_out)
		{	$thisarg=$outlist[$y];
			if ($comparison=="LIKE")
			{	$thisarg = "%" . $thisarg . "%";
			}
			if ($quotesornot=="SingleQuoted")
			{	$thisarg = "'" . $thisarg . "'";
			}
			else if ($quotesornot=="DoubleQuoted")
			{	$thisarg = "\"" . $thisarg . "\"";
			}
			if ($comparison=="=")
			{	$finalcompare="!=";
			}
			else if ($comparison=="LIKE")
			{	$finalcompare="NOT LIKE";
			}
			if ($y>0 && $forceor==false)
			{	$quer .= "\nAND";
			}
			else if ($y>0 && $forceor==true)
			{	$quer .= "\nOR";
			}

			$quer .= " urlinfo.$field $finalcompare $thisarg";
			$y++;
		}
		$quer .= ")";
	}
	return $quer;
};


function ArrayWalkInOrNot($inp)
{	global $outlist, $inlist;

	$test=substr($inp, 0, 1);
	if ($test=="!")
	{	$res=substr($inp,1);
		$res=trim($res);
		array_push($outlist,$res);
	}
	else
	{
		array_push($inlist,$inp);
	}
}

function EncloseInSomething(&$value, $key, $enclosure)
{
	$reverse_enclosure=strrev($enclosure);
	$value = $enclosure . $value . $reverse_enclosure;
}

function trim_value(&$value) 
{
    $value = trim($value);
}

function ArrayWalkPlaToNum(&$inp)
{	global $menames, $venames, $manames, $junames, $sanames, $urnames, $nenames, $plnames, $ernames;

	if ( is_numeric($inp) )
	{	if ($inp>10 || $inp<0)
		{	$inp=0;
		}
		else
		{	return $inp;
		}
	}
	else
	
	if ( in_array($inp, $menames) )
	{	$inp = 1;
	}
	elseif ( in_array($inp, $venames) )
	{	$inp = 2;
	}
	elseif ( in_array($inp, $manames) )
	{	$inp = 3;
	}
	elseif ( in_array($inp, $junames) )
	{	$inp = 4;
	}
	elseif ( in_array($inp, $sanames) )
	{	$inp = 5;
	}
	elseif ( in_array($inp, $urnames) )
	{	$inp = 6;
	}
	elseif ( in_array($inp, $nenames) )
	{	$inp = 7;
	}
	elseif ( in_array($inp, $plnames) )
	{	$inp = 8;
	}
	elseif ( in_array($inp, $ernames) )
	{	$inp = 9;
	}
}
?>